function crm00050000_Revenda_Controller(General, ScreenService, CRM_Utilities, templateManager, crm00050000_Revenda_Service, crm00050000_Interlocutor_Revenda_Repository, crm00050000_Interlocutor_Revenda_Controller, restEngine,  AbaInterlocutorController, ABAEnderecoParceiroController, ZhFilterPreferences) {
    
    
    /**
     * Método para selecionar a função save 
     * de acordo com a rotina (insert, update);
     * 
     * @param {object(widget)} widget widget onde
     * estão os objetos para o save.
    */
    this.save = function(widget){
        var currentRow = widget.currentRow;
        if(widget.isValid()) {
            if(currentRow.__is_new){
                var widgetEndereco = templateManager.container.getWidget('WDGT_ENDERECOS');
                if(!currentRow.CDCLIENTE) {
                    if(widgetEndereco.isValid()) {
                        this.setValuesAndSaveNewResale(widget);  
                        this.ocultaInterlocutor();
                    }else{
                        this.openTabEndereço(widget);
                    }
                }else{
                    this.getEnderecoCliente(currentRow).then(function(response) {
                        if(response.dataset.DADOS.POSSUIENDERECO) {
                            this.setValuesAndSaveNewResale(widget);
                            this.ocultaInterlocutor();
                        }else{
                            this.openTabEndereço(widget);    
                        }
                    }.bind(this));
                }
            }else{
                
                this.setValuesAndEditResale(widget);
                this.ocultaInterlocutor();
                
            }
        }
    }; 
    
    this.deleteRevenda = function(widget){
      ScreenService.confirmMessage('Deseja realmente excluir a Revenda?', 'QUESTION',
        function(success){
            var paramsRestEngine = {
                requestType:'Row',
                row:widget.currentRow
            };
            
            restEngine.post('product#/crm_revenda/deleteRevenda', paramsRestEngine).
                then(function(response){
                    
                        ScreenService.showMessage('Revenda excluida');
                        ScreenService.closeSwipe().then(function(){
                            ScreenService.closePopup(true);
                            widget.reload();
                        });
                        
                }).catch(function(error){
                    ScreenService.showMessage(error.data.error);    
                });        
        }, 
          function(cancel){
            
        });
        

        
    };
    
     /**
     * Verifica se já existem clientes vinculados
     * aquela inscrição ou nome
    */
    this.getEnderecoCliente = function(currentRow){
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/getEndeClie', paramsRestEngine);
    };
    
    
    /**
     * Método para abrir a tab de endereço se a revenda
     * selecionada não for gerada automaticamente pelo cliente.
     * 
     * @param {object(widget)} widget principal da revenda
    */
    this.openTabEndereço = function(widget){
        
        var enderecoWidget = templateManager.container.getWidget('WDGT_ENDERECOS');
        
        if(enderecoWidget.template !== 'widget/form.html'){
            enderecoWidget.template = 'widget/form.html';
        }
        
        CRM_Utilities.overwriteAction(enderecoWidget, "SALVAR_ENDERECO", "crm00050000_Revenda_Controller.prepareResaleAdress(args.owner.widget);");
        
        enderecoWidget.actions.forEach(function(action){
            if(action.name !== "SALVAR_ENDERECO"){
                action.isVisible = false;
            }else{
                action.isVisible = true;
            }
        });
        
        enderecoWidget.enabled = true;
        enderecoWidget.reload();
        enderecoWidget.newRow();
        
        widget.openTab(enderecoWidget.name);
        
    };
    
    /**
     * Método para preparar os dados de endereço 
     * da revenda
     * 
     * @param {object(widget)} widget de endereco
    */
    this.prepareResaleAdress = function(widget){
        var widgetPrincipal;
        
        if(widget.isValid()){
            if(!Util.isUndefined(widget.parent.parent)) {
                widgetPrincipal = widget.parent.parent;
            } else {
                widgetPrincipal = widget.parent;
            }
            
            widgetPrincipal.currentRow.ENDERECO = widget.currentRow;
            
            widget.currentRow = widget.getDefaultValues().currentRow;
            this.setValuesAndSaveNewResale(widgetPrincipal);
            
        }
    };
    
    /**
     * Função preparada para receber um
     * novo cadastro de revenda,inserindo
     * um novo parceiro de negócio e editando
     * os valores necessários.
     * 
     * @param {object(widget)} widget widget
     * ativa, contendo os objetos para o save.
    */
    this.setValuesAndSaveNewResale = function(widget){
        
        var currentRow = widget.currentRow;
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        if(widget.isValid()){
            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
            currentRow.NRINSCRIREVENDA = this.removeInscriptionMask(currentRow.NRINSCRIREVENDA);
            currentRow.CDTIPOINSCRICAO = this.convertClientInscTypeToDefaultInscType(currentRow.CDTIPOINSCRICAO);
            
            this.checkIfEmptyFantasyName(currentRow);
            
            if(currentRow.CDCLIENTE){
                currentRow.__newClient = false;
            }else{
                currentRow.__newClient = true;
                currentRow.CDCLIENTE = '';
            }
            
            crm00050000_Revenda_Service.callInsertParcNegocioRoute(currentRow).then(function(){
                
                var rowIntelroc = angular.copy(widget.currentRow);
                
                rowIntelroc.NRRELACIONAPARC = '';
                rowIntelroc.NRPARCNEGOCIOREV = currentRow.NRPARCNEGOCIO;
                rowIntelroc.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
                
                this.saveInterlocResale(widget.currentRow).then(function(interlocutor){
                    
                    this.setColumnToBeReturned(currentRow, "NRREVENDA");
                    General.widgetSave(widget).then(function(response){
                        
                        var resaleCode = response.dataset.columnsToReturn.NRREVENDA;
                        this.setResaleCodeAtCurrentRowResale(currentRow, resaleCode);
                        this.replicaRevenda(currentRow);
                        this.goBackWidgetEndereco();
                        
                        var widgetEndereco = templateManager.container.getWidget('WDGT_ENDERECOS');
                        CRM_Utilities.setActionDefaultCode(widgetEndereco, "SALVAR_ENDERECO");
                        
                    }.bind(this));
                }.bind(this));
            }.bind(this));
        }
        
    };
    
    this.saveInterlocResale = function(currentRow){
        
        var resaleWidget = templateManager.container.getWidget('WDGT_REVENDA');
        var interlocutorWidgetIndex = CRM_Utilities.getObjectPositionInArrayByName(resaleWidget.widgets, "WDGT_INTERLOCUTOR");
        var widget = resaleWidget.widgets[interlocutorWidgetIndex];
        var parentWidget;
        
        if(!Util.isUndefined(widget.parent.parent)) {
            parentWidget = widget.parent.parent;
        } else {
            parentWidget = widget.parent;
        }
        
        var loggedOperatorInfos = parentWidget.OPERATORLOGGED;
        var rowIntelroc = {};
        
        rowIntelroc.INTERLOCUTOR = parentWidget.currentRow.INTERLOCUTOR;
        rowIntelroc.NRPARCNEGOCIOREV = parentWidget.currentRow.NRPARCNEGOCIO;
        rowIntelroc.NRTELEFONEINTERLOC = parentWidget.currentRow.NRTELEFONEINTERLOC;
        rowIntelroc.DSEMAILINTERLOC = parentWidget.currentRow.DSEMAILINTERLOC;
        rowIntelroc.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
        rowIntelroc.NRORG = loggedOperatorInfos.NRORG;
        rowIntelroc.IDATIVO = 'S';
        widget.currentRow = rowIntelroc;
        
        return crm00050000_Revenda_Service.callInsertNewResaleInterlocutor(widget.currentRow);
        
    };
    
     /**
     * Função para pegar os dados de comunicação 
     * da revenda e montar um object, para salvar
     * na comunicaparc
     * 
     * @param {object(field)} field contendo
     * name e value dos modos de comunicação.
    */
    this.buildComunicaparc = function(field){
        var currentRow = field.widget.currentRow;
        if(!Util.isEmptyOrBlank(field.value())){
            if(!currentRow.__is_new){
                currentRow.OLDCOMUNICAPARC = angular.copy(currentRow.COMUNICAPARC);
            }
            var objCom = {name:field.name, value:field.value()};
            if(currentRow.COMUNICAPARC){
               currentRow.COMUNICAPARC.forEach(function(comunicacao){
                    if(comunicacao.name === objCom.name){
                        comunicacao.value = objCom.value;
                    }else if(currentRow.COMUNICAPARC.length<2){
                        currentRow.COMUNICAPARC.push(objCom);    
                    }
               });
            }else{
                currentRow.COMUNICAPARC = [objCom];
            }
        }
    };
    
    this.buildComunicaparcAfterMoveRow = function(widget){
        var fieldEmail = widget.getField('DSEMAILREVENDA');
        var fieldTelefone = widget.getField('NRTELREVENDA');
        
        this.buildComunicaparc(fieldEmail);
        this.buildComunicaparc(fieldTelefone);
    };
    
    this.replicaRevenda = function(currentRow){
        return crm00050000_Revenda_Service.callReplicaRevenda(currentRow);    
    };
    
    this.widgetCancelForm = function(widget){
        General.widgetCancelForm(widget);
        this.goBackWidgetEndereco();
    };
    
    this.goBackWidgetEndereco = function(){
        
        var widgetEndereco = templateManager.container.getWidget('WDGT_ENDERECOS');
        
        widgetEndereco.template = 'widget/master_detail/grid.html';
        
        widgetEndereco.currentRow = widgetEndereco.getDefaultValues().currentRow;
        
        widgetEndereco.list();
        widgetEndereco.reload();
        
        widgetEndereco.actions.forEach(function(action){
            action.isVisible = true;
        });
        
    };
    
    /**
     * Função preparada para salvar
     * as alterações de uma revenda,
     * editando os valores necessários e 
     * setando a inscrição formatada para o 
     * modo view depois que o save for realizado.
     * 
     * @param {object(widget)} widget widget
     * ativa, contendo os objetos para o save.
    */
    this.setValuesAndEditResale = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NRINSCRIREVENDA = this.removeInscriptionMask(currentRow.NRINSCRIREVENDA);
        
        this.checkIfEmptyFantasyName(currentRow);
            
            General.widgetSave(widget).then(function(){
                
                this.formatsResaleInscription(widget);
                
            }.bind(this));
        
    };
    
    /**
     * Função para setar na currentRow recebia
     * a coluna que será retonarda depois que
     * o save for realizado
     * 
     * @param {object} currentRow currentRow que irá
     * receber o parâmetro da coluna a ser retornada.
     * 
     * @param {String} columnName Nome da coluna a ser 
     * retornada.
    */
    this.setColumnToBeReturned = function(currentRow, columnName){
    
        currentRow.__columns_to_return = [columnName];
        
    };
    
    /**
     * Função para setar o código da revenda em
     * sua pŕopria currentRow, para ser exibida 
     * no mode view sem precisar dar um reload na widget.
     * 
     * @param {object} resaleCurrentRow currentRow 
     * da revenda salva.
     * 
     * @param {int} resaleCode Código gerado para a 
     * nova revenda.
    */
    this.setResaleCodeAtCurrentRowResale = function(resaleCurrentRow, resaleCode){
    
        resaleCurrentRow.NRREVENDA = resaleCode;
    
    };
    
    /**
    * Função para remover todos os caracteres não
    * numércios do número de inscrição recebida.
    * 
    * @param {int} inscription Inscrição que será
    * edita.
    * 
    * @return {int} inscription Inscrição editada.
    */
    this.removeInscriptionMask = function(inscription){
    
        return inscription.replace(/[^0-9]/g, ""); 
        
    };
    
    /**
     * Função para setar o nome fantasia de uma revenda
     * caso ela não fosse informada.
     * 
     * @param {object} currentRow currentRow da revenda
     * em processo de cadastro.
    */
    this.checkIfEmptyFantasyName = function(currentRow){
    
        if(!currentRow.NMFANTREVENDA){
            
            currentRow.NMFANTREVENDA = currentRow.NMRAZSOCREVENDA;
            
        }
        
    };
    
    /**
     * Função para preparar o ambiente de cadastro
     * de uma nova revenda, setando:
     * 
     * O operador logado na currentRow,
     * 
     * @param {object(widget)} widget widget onde será
     * cadastrada a nova revenda.
    */
    this.prepareSwipeForResaleRegister = function(widget){
      
        this.setOperatorLogged(widget);
        
    };
    
    
    /**
     * Valida a inscrição informada pelo usuário
     * e seta na currentRow da widget o código do
     * tipo da inscrição através do método 
     * 'setInscriptionTypeInCurrentRow', e a máscara
     * da inscrição, caso a inscrição seja inválida,
     * ele limpa os campos e manda uma mensagem.
     * 
     * @param {object} widget widget onde está sendo
     * realizado o cadastro da revenda.
    */
    this.validateResaleInscription = function(widget){
        
        var currentRow = widget.currentRow;
        
        var resultValidate = General.inscricaoFormat(currentRow.NRINSCRIREVENDA);
        
        if(resultValidate.valid && resultValidate.value){
            
            this.setInscriptionTypeInCurrentRow(widget, resultValidate.tipo.cod);
            
            this.setFormatedInscriptionInCurrentRow(widget, resultValidate.value);
            
            if(!widget.currentRow.CDCLIENTE){
                this.verificaClienteExistente(widget.currentRow).then(function(response){
                    var cliente = response.dataset.DADOS.CLIENTES[0] ? response.dataset.DADOS.CLIENTES[0] : '';
                    if(!Util.isEmptyOrBlank(cliente)){
                        ScreenService.confirmMessage('Este número de inscrição já está vinculado ao Cliente: <br>'+cliente.NMRAZSOCCLIE+'<br> Gostaria de importar os dados deste Cliente para a Revenda? ', 'CONFIRMATION',
                        function(success){
                            widget.currentRow.CDCLIENTE       = cliente.CDCLIENTE;
                            widget.currentRow.NMRAZSOCCLIE    = cliente.NMRAZSOCCLIE;
                            widget.currentRow.NMFANTREVENDA   = cliente.NMRAZSOCCLIE;    
                            widget.currentRow.NMRAZSOCREVENDA = cliente.NMRAZSOCCLIE;
                        }); 
                    }
                });
            }
        }else{
            
            this.showErrorMessageForInscription(currentRow.NRINSCRIREVENDA.length);
            
            currentRow.NRINSCRIREVENDA = "";
            currentRow.CDTIPOINSCRICAO = "";
        }
        
    };
    
    /**
     * Verifica se já existem clientes vinculados
     * aquela inscrição ou nome
    */
    this.verificaClienteExistente = function(currentRow){
        var paramsRestEngine = {
            "requestType": "Row",
            "row": currentRow
        };
        return restEngine.post('/validaCliente', paramsRestEngine);
    };
    
    /**
     * Função para setar a inscrição formatada
     * na currentRow (quando a widget ativa não for um filtro).
     * 
     * @param {object(widget)} widget widget ativa
     * onde está sendo realizada o cadastro da revenda.
     * 
     * @para {int} formatedInscription inscrição formatada.
    */
    this.setFormatedInscriptionInCurrentRow = function(widget, formatedInscription){
        
        var currentRow = widget.currentRow;
        
        if(widget.name !== "filterPopup"){
            currentRow.NRINSCRIREVENDA = formatedInscription;
        }
        
    };
    
    /**
     * Função para exibir a mensagem de erro referente
     * ao número de inscrição informado.
     * 
     * @param {int} inscription número de inscrição informado.
    */
    this.showErrorMessageForInscription = function(inscription){
    
        if(inscription){
    
            switch(inscription){
                
                case 11:
                    ScreenService.showMessage("Número de CPF inválido.");
                    break;
                case 14:
                    ScreenService.showMessage("Número de CNPJ inválido.");
                    break;
                default:
                    ScreenService.showMessage("Número de incrição inválido.");
            }
        
        }
        
    };
    
    /**
     * Seta na currentRow da widget, o código
     * da inscrição informada.
     * 
     * @param {object} widget onde está sendo 
     * realizada o cadastro da revena.
     * 
     * @param {int} inscriptionCod código da 
     * inscrição informada.
    */
    this.setInscriptionTypeInCurrentRow = function(widget, inscriptionCod){
        
        var currentRow = widget.currentRow;
        
        if (inscriptionCod){
            
            switch(inscriptionCod){
                
                case "F":
                    currentRow.CDTIPOINSCRICAO = "CPF";
                break;
                
                case "J":
                    currentRow.CDTIPOINSCRICAO = "CNPJ";
                break;
                
                case "O":
                    currentRow.CDTIPOINSCRICAO = "CODIGO";
                break;
                
                case "I":
                    currentRow.CDTIPOINSCRICAO = "LIVRE";
                break;
            }
            
        }
    };
    
    /**
     * Função para formatar a inscrição quando o modo
     * view for chamado.
     * 
     * @param {object(widget)} widget widget ativa
     * entrando no mode view.
    */
    this.formatsResaleInscription = function(widget){
            
            var currentRow = widget.currentRow;
            var inscription = currentRow.NRINSCRIREVENDA;
            
            if(inscription){
            
                switch (inscription.length) {
                    case 11:
                        
                        inscription = inscription.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/, "$1.$2.$3-$4");
                    break;
                    
                    case 14:
                        
                        inscription = inscription.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/, "$1.$2.$3/$4-$5");
                    break;
                }
        
                currentRow.NRINSCRIREVENDA = inscription;
            }
    };
    
    /**
     * Função para setar o operador logado na
     * field 'NMOPERADOR' da widget.
     * 
     * @param {object(widget)} widget widget 
     * 'REVENDA' no ambiente de cadastro.
    */
    
    this.setOperatorLogged = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.NMOPERADOR = widget.OPERATORLOGGED.NMOPERADOR;
        currentRow.CDOPERREVENDA = widget.OPERATORLOGGED.CDOPERADOR;
        currentRow.NRORG = widget.OPERATORLOGGED.NRORG;
        
    };
    
    /**
     * todo - função para criar a variável (escrita errada)
     * usada nos controllers da rotina de revenda, com as
     * informações do operador logado.
     * 
     * Trocar o nome das variáveis para o nome correto (LOGGEDOPERATOR)
     * 
     * @param {object} widget de revenda.
    */
    this.setLoggedOperatorInfosInResaleWidget = function(widget){
        
        widget.OPERATORLOGGED = templateManager.LOGGEDOPERATOR;
        
    };
    
    /**
     *  Funções para manipular is visible e readOnly
     *  no crud    
     **/
    this.setReadOnlyClient = function(widget, readOnly){
        var clientField = widget.getField('NMRAZSOCCLIE');
        clientField.readOnly = readOnly;
        clientField.reload();
        
        var inscriptionField = widget.getField('NRINSCRIREVENDA');
        inscriptionField.readOnly = readOnly;
        inscriptionField.reload();
        
        var razSocField = widget.getField('NMRAZSOCREVENDA');
        razSocField.readOnly = readOnly;
        razSocField.reload();
    };
    
    this.widgetEdit = function(widget){
        widget.fields.forEach(function (field){
           if(field.fieldGroup === 'INTERLOCUTOR'){
               field.isVisible = false;
           } 
        }); 
        this.setReadOnlyClient(widget, true);
        General.widgetEdit(widget);
    };
    
    this.ocultaInterlocutor = function(){
        var widget = templateManager.container.getWidget('WDGT_REVENDA');
            widget.fieldGroups.forEach(function (row){
            if(row.name == 'INTERLOCUTOR'){
              row.isVisible = false;  
                }
           });
      widget.reload();
        
    };
    
    this.widgetNewRow = function(widget){     
        var wid = templateManager.container.getWidget('WDGT_REVENDA');
        
        
        wid.fieldGroups.forEach(function (row){
            if(row.name == 'INTERLOCUTOR'){
              row.isVisible = true;  
            }
           });
      
        wid.reload();
        
        widget.fields.forEach(function (field){
           if(field.fieldGroup === 'INTERLOCUTOR'){
               field.isVisible = true;
           } 
        }); 
        this.setReadOnlyClient(widget, false);
        General.widgetNewRow(widget);    
    };
    /**
     * Fim funções de manipulação isVisible/Readonly 
     * no crud
     */
     
    this.setCurrentRowByClient = function(widget){
        var currentRow = widget.currentRow;
        currentRow.NMRAZSOCREVENDA = currentRow.NMRAZSOCCLIE;
    };
    
    /**
     * Converte o tipo de inscrição salvo na tabela ('CLIENTE')
     * para os tipos padrões, registrados na tabela ('TIPOINSCRICAO').
     * 
     * @param {string} inscCode código da inscrição do cliente.
     * 
     * @return {string} formato padrão de inscrição referente.
    */
    this.convertClientInscTypeToDefaultInscType = function(inscCode){
        
        switch(inscCode){
            
            case 'J':
                return "CNPJ";
            case 'F':
                return "CPF";
            case 'O':
                return "CODIGO";
            case 'I':
                return "LIVRE";
        }
        
        return inscCode;
        
    };
    
     /**
     * Executa as funções necessárias no evento
     * "WidgetOnEnterOnce" da widget de revenda.
     * 
     * @param {object} widget widget de revenda
     * ("WDGT_REVENDA").
    */
    this.widgetOnEnterOnce = function(widget, fieldsToApply){
        
        var filterRow = {};
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
        
        
        ABAEnderecoParceiroController.setAddressWidgetOnActiveWidget(widget, 1);
        AbaInterlocutorController.setInterlocutorWidgetOnActiveWidget(widget, 3); 
        
        this.setLoggedOperatorInfosInResaleWidget(widget);
        
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("crm00050000_Revenda_Controller", crm00050000_Revenda_Controller);
});
