function taskTabController(ScreenService, templateManager, metaDataFactory){
    
    /**
     * Tranforma o JSON da tab em uma widget de fato.
     * 
     * @param {object} widget widget que irá receber a tab.
     * 
     * @param {string} nrparcnegocio nome do campo com o número
     * do parceiro de negócio.
     * 
     * @return widget evolucao construida.
     * 
    */
    function _factoryTaskTab(activeWidget) {
        
        
        var taskTabWidgetJson = {
            "id": "165190053618173611545287",
            "name": "WDGT_TAREFAS",
            "container":activeWidget.container,
            "parent":activeWidget,
            "label": "Agenda de Tarefas",
            "isVisible": true,
            "showDescriptionOrder": false,
            "template": "widget/master_detail/grid.html",
            "dataSource": {
                "name": "product#/filacontato_agendatarefas",
                "rest": true,
                "lazyLoad": false
            },
            "dataSourceFilter": [
                {
                    "name": "NRSEQCONTATO",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "NRORG",
                    "operator": "=",
                    "value": "@templateManager.LOGGEDOPERATOR.NRORG@"
                }
            ],
            "events": [
                {
                    "id": "12145938358850258985322",
                    "name": "WidgetOnEnterOnce",
                    "code": "CRM_Utilities.factoryWidgetActions(args.owner)"
                },
                {
                    "id": "12145938359454958305323",
                    "name": "WidgetOnEnter",
                    "code": "CRM_Utilities.setDataSourceFilterOnDynamicTabs(args.owner, templateManager.container.getWidget('" + activeWidget.name + "'))"
                }
            ],
            "actions": [
                {
                    "id": "12145938358778860855308",
                    "name": "ADD",
                    "isVisible": true,
                    "label": "Adicionar",
                    "icon": "plus",
                    "showAsAction": "always|list",
                    "events": [
                        {
                            "id": "1214593835687091805309",
                            "name": "ActionEvent",
                            "code": "General.widgetNewRow(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "121459383529023736205310",
                    "name": "BACK_EDIT",
                    "label": "Cancelar",
                    "isVisible": true,
                    "showAsAction": "back_edit",
                    "events": [
                        {
                            "id": "12145938352536628455311",
                            "name": "ActionEvent",
                            "code": "General.widgetCancelForm(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "121459383515432103205312",
                    "name": "BACK_LIST",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide": true,
                    "showAsAction": "back_list",
                    "events": [
                        {
                            "id": "121459383539130013215313",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToParent(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "12145938354105660785314",
                    "name": "BACK_VIEW",
                    "label": "Voltar",
                    "isVisible": true,
                    "preventHide": true,
                    "showAsAction": "back_view",
                    "events": [
                        {
                            "id": "12145938355192145735315",
                            "name": "ActionEvent",
                            "code": "General.widgetGoBackToList(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "121459383523551511425316",
                    "name": "SAVE",
                    "label": "Salvar",
                    "isVisible": true,
                    "showAsAction": "never_edit",
                    "events": [
                        {
                            "id": "121459383521319591925317",
                            "name": "ActionEvent",
                            "code": "General.widgetSave(args.owner.widget)"
                        }
                    ]
                },
                {
                    "id": "121459383512178699915318",
                    "name": "EDIT",
                    "label": "Editar",
                    "isVisible": true,
                    "icon": "pencil",
                    "showAsAction": "view",
                    "events": [
                        {
                            "id": "121459383538831883375319",
                            "name": "ActionEvent",
                            "code": "General.widgetEdit(args.owner.widget);"
                        }
                    ]
                },
                {
                    "id": "121459383527596916025320",
                    "name": "DELETE",
                    "label": "Excluir",
                    "isVisible": true,
                    "icon": "trash",
                    "showAsAction": "view",
                    "events": [
                        {
                            "id": "121459383522857367935321",
                            "name": "ActionEvent",
                            "code": "General.deleteCrud(args.owner.widget);"
                        }
                    ]
                }
            ],
            "fields": [
                {
                    "id": "121459383521799955325288",
                    "name": "DSFILACONTATO",
                    "label": "Assunto",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "maxlength": 2000,
                    "class": "12",
                    "validations": {
                        "required": {}
                    },
                    "events": [],
                    "descriptionOrder": 1
                },
                {
                    "id": "121459383524658483795289",
                    "name": "DSCLASSIFICATAREFA",
                    "label": "Classificação da Tarefa",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "fields": [
                        {
                            "id": "121459383535174967265290",
                            "name": "DSCLASSIFICATAREFA",
                            "label": "Classificação da Tarefa",
                            "showOnList": true,
                            "isVisible": true,
                            "template": "field/text-edit.html"
                        }
                    ],
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "valueField": "NRSEQCLASSIFICATAREFA",
                    "descriptionField": "DSCLASSIFICATAREFA",
                    "dataSource": {
                        "name": "product#/crm_classificatarefa",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "validations": {
                        "required": {}
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [],
                    "outData": {
                        "NRSEQCLASSIFICATAREFA": "NRSEQCLASSIFICATAREFA",
                        "DSCLASSIFICATAREFA": "DSCLASSIFICATAREFA"
                    },
                    "events": []
                },
                {
                    "id": "121459383524336115205291",
                    "name": "DTPLANFILACONTA",
                    "label": "Data/Hora de Contato",
                    "template": "field/datetime.html",
                    "datetime-preset": "datetime",
                    "datetime-dateFormat": "dd/mm/yy",
                    "datetime-timeFormat": "HH:ii",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "defaultValue": "@CRM_Utilities.getDataHoraAtual()@",
                    "validations": {
                        "required": {}
                    },
                    "events": []
                },
                {
                    "id": "12145938357360006555292",
                    "name": "NMOPERADOR",
                    "label": "Operador Responsável",
                    "template": "field/select.html",
                    "class": "12",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "valueField": "CDOPERREAL",
                    "descriptionField": "NMOPERADOR",
                    "validations": {
                        "required": {}
                    },
                    "defaultValue": "@getLocalVar('CRM_NMOPERADOR')@",
                    "dataSource": {
                        "name": "product#/crud/operador_crm_operrevenda",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [],
                    "fields": [
                        {
                            "id": "12145938352562112795293",
                            "name": "NMOPERADOR",
                            "label": "Nome",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "outData": {
                        "NMOPERADOR": "NMOPERADOR",
                        "CDOPERADOR": "CDOPERREAL"
                    },
                    "events": []
                },
                {
                    "id": "121459383521168607645294",
                    "name": "CDOPERREAL",
                    "label": "Código Operador",
                    "template": "field/datetime.html",
                    "showOnForm": false,
                    "showOnList": false,
                    "isVisible": false,
                    "readOnly": false,
                    "class": "6",
                    "defaultValue": "@templateManager.LOGGEDOPERATOR.CDOPERADOR@",
                    "events": []
                },
                {
                    "id": "121459383537971805055295",
                    "name": "NMPRIORFILACONT",
                    "label": "Prioridade",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "class": "6",
                    "events": []
                },
                {
                    "id": "1214593835389562785296",
                    "name": "DTREALFILACONTA",
                    "label": "Data de Conclusão",
                    "template": "field/calendar.html",
                    "isVisible": true,
                    "showOnList": true,
                    "showOnView": true,
                    "showOnForm": true,
                    "readOnly": true,
                    "dateFormat": "DD/MM/YYYY",
                    "class": "6",
                    "events": []
                },
                {
                    "id": "12145938359203751095297",
                    "name": "NRPRIORFILACONT",
                    "label": "Prioridade",
                    "template": "field/select-native.html",
                    "hideEmptyValue": true,
                    "isVisible": true,
                    "showOnList": false,
                    "showOnForm": true,
                    "showOnView": true,
                    "class": "6",
                    "dataSource": {
                        "data": [
                            {
                                "NRPRIORFILACONT": 2,
                                "NMPRIORFILACONT": "Normal"
                            },
                            {
                                "NRPRIORFILACONT": 1,
                                "NMPRIORFILACONT": "Prioridade"
                            }
                        ]
                    },
                    "descriptionField": "NMPRIORFILACONT",
                    "valueField": "NRPRIORFILACONT",
                    "defaultValue": 2,
                    "validations": {
                        "required": true
                    }
                },
                {
                    "id": "121459383525106681375298",
                    "name": "NMINTERLOCUTOR",
                    "label": "Interlocutor",
                    "template": "field/select.html",
                    "showSelectAs": "grid",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": false,
                    "readOnly": false,
                    "class": "6",
                    "valueField": "NRSEQINTERLOCUTOR",
                    "descriptionField": "NMINTERLOCUTOR",
                    "dataSource": {
                        "name": "product#/crm_interlocutor",
                        "rest": true,
                        "lazyLoad": true
                    },
                    "itemsPerPage": 50,
                    "dataSourceFilter": [
                        {
                            "name": "NRPARCNEGOCIO",
                            "operator": "=",
                            "value": "@General.getFieldValue('NRPARCNEGOCIO', '"+activeWidget.name+"')@"
                        },
                        {
                            "name": "NRORG",
                            "operator": "=",
                            "value": "@getLocalVar('CRM_NRORGTRAB')@"
                        }
                    ],
                    "outData": {
                        "NRSEQINTERLOCUTOR": "NRSEQINTERLOCUTOR",
                        "EMAILINTERLOC": "EMAILINTERLOC",
                        "NRTELEFONE1": "NRTELEFONE1",
                        "NMINTERLOCUTOR": "NMINTERLOCUTOR"
                    },
                    "fields": [
                        {
                            "id": "12145938353104527715299",
                            "name": "NMINTERLOCUTOR",
                            "label": "Nome Interlocutor",
                            "isVisible": true,
                            "showOnList": true
                        }
                    ],
                    "events": [
                        {
                            "id": "121459383538789140965300",
                            "name": "FieldAfterSelectOpen",
                            "code": "args.owner.field.reload()"
                        }
                    ],
                    "filterProperties": {
                        "isVisible": false,
                        "showOnForm": false
                    }
                },
                {
                    "id": "121459383512624111745301",
                    "name": "DSTELEFONETAREFA",
                    "label": "Telefone",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "maxlength": 15,
                    "events": []
                },
                {
                    "id": "121459383542832204335302",
                    "name": "DSEMAILTAREFA",
                    "label": "E-mail",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "class": "6",
                    "validations": {
                        "mail": true
                    },
                    "events": []
                },
                {
                    "id": "12145938354756362625303",
                    "name": "DSDETEFILACONTA",
                    "label": "Descrição",
                    "template": "field/textarea.html",
                    "textRows": 5,
                    "isVisible": true,
                    "showOnList": false,
                    "showOnView": true,
                    "showOnForm": true,
                    "maxlength": 4000,
                    "class": "12",
                    "events": []
                },
                {
                    "id": "12145938359935862175304",
                    "name": "NRORG",
                    "label": "Org",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue": "@templateManager.LOGGEDOPERATOR.NRORG@"
                },
                {
                    "id": "121459383530261645445305",
                    "name": "CDOPEREVOL",
                    "label": "Operador",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue": "@templateManager.LOGGEDOPERATOR.CDOPERADOR@"
                },
                {
                    "id": "121459383516284260395306",
                    "name": "NRPARCNEGOCIO",
                    "label": "Parceiro",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue":"@templateManager.container.getWidget('" + activeWidget.name + "').currentRow.NRPARCNEGOCIO@"
                },
                {
                    "id": "12145938352448535765307",
                    "name": "NRSEQCONTATO",
                    "label": "Contato",
                    "template": "field/text-edit.html",
                    "isVisible": false,
                    "showOnList": false,
                    "showOnView": false,
                    "showOnForm": false,
                    "defaultValue":"@templateManager.container.getWidget('" + activeWidget.name + "').currentRow.NRSEQCONTATO@"
                }
            ],
            "widgets": []
        };
        
        var taskTabWidget = metaDataFactory.widgetFactory(taskTabWidgetJson);
        taskTabWidget.widgets = [];
        
        return taskTabWidget;
        
    };
    
    /**
     * Insere a widget de tarefas na widget recebida como 
     * parâmetro.
     * 
     * @param {object} widget widget que receberá a tab.
     * 
     * @param {string} nrparcnegocio nome referente ao
     * campo de parceiro de negócio.
    */
    this.setTaskTabOnActiveWidget = function(widget, nrparcnegocio){
        
        widget.widgets.push(_factoryTaskTab(widget, nrparcnegocio));
        
    };

    
	
}
Configuration(function(ContextRegister){
    ContextRegister.register('taskTabController', taskTabController);
});