/*global $, angular, Util*/
var ZeedhiFields = angular.module("ZeedhiFields");

ZeedhiFields.directive('zhButtonMultiple', function($compile, $timeout, templateManager, maskEngine, ZhUtil) {
	return {
		link: function($scope, elem) {
			var field = $scope.field;
			var options = [];
			
		    function __setOptions(value){
        	    var alreadySelected = false;
        	    options.forEach(function(option, index){
        	        if(option === value)
        	            alreadySelected = index;
        	    });
        	    //If options is alreay selected, remove it, otherwise push it
        	    if(alreadySelected !== false){
        	        options.splice(alreadySelected, 1);
        	    }else{
        	        options.push(value);
        	    }
        	    field.widget.currentRow[field.name] = '';
        	    field.widget.currentRow[field.name] = options.join(',');
        	}
        	
        	//Green to selected and grey otherwise
        	$scope.__changeColor = function(button){
        	    if(options.indexOf(button.text()) !== -1){
        	        button.css({backgroundColor:'#479e45'});
        	    }else{
        	        button.css({backgroundColor:'#565656'});
        	    }
        	};
        	
        	
        	$scope.clickButton = function(evt) {
        	    var $button = $(evt.currentTarget);
        	    __setOptions($button.text()); 
        	    $scope.__changeColor($button);
        	};
        	
        	$scope.__finishButtonsRepeat = function(){
        	    //get options from currentRow
        	    options = (!Util.isEmptyOrBlank(field.widget.currentRow[field.name])) ? field.widget.currentRow[field.name].split(',') : [];
        	    elem.find('button').each(function(){
        	        $(this).text($(this)[0].label);
        	        $scope.__changeColor($(this));    
        	    });
        	    $scope.__calcSize();
        	};
        	
        	$scope.__calcSize = function() {
        	    //@TODO improve size calculation
        	    var qtOptions = $('.btn-multiple').length;
        	    var windoWidth = $(window).width()-((12*qtOptions)+(qtOptions*1.5));
        	    var constant = windoWidth <= 360 ? 2 : qtOptions;
        	    $('.btn-multiple').css({width:(windoWidth/constant)});
        	};
        	
        	$(window).resize(function(){
        	    $scope.__calcSize();    
        	});
        	
		}
	};
});

ZeedhiFields.directive('zhButtonsRepeat', function($compile, $timeout, templateManager, maskEngine, ZhUtil) {
  return function(scope, element, attrs) {
    //set the label to the element
    element[0].label = scope.button.label;
    //catching repeat's end
    if (scope.$last){
      scope.__finishButtonsRepeat();
    }
  };
});
